diff --git a/MAINTAINERS b/MAINTAINERS
index c83475103a25..2e2fc3c2b338 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -15081,12 +15081,12 @@ F:	drivers/iio/adc/imx7d_adc.c
 F:	drivers/iio/adc/imx93_adc.c
 F:	drivers/iio/adc/vf610_adc.c
 
-NXP i.MX 8M ISI DRIVER
+NXP i.MX ISI DRIVER
 M:	Laurent Pinchart <laurent.pinchart@ideasonboard.com>
 L:	linux-media@vger.kernel.org
 S:	Maintained
-F:	Documentation/devicetree/bindings/media/nxp,imx8-isi.yaml
-F:	drivers/media/platform/nxp/imx8-isi/
+F:	Documentation/devicetree/bindings/media/nxp,imx-isi.yaml
+F:	drivers/media/platform/nxp/imx-isi/
 
 NXP i.MX 8MP DW100 V4L2 DRIVER
 M:	Xavier Roumegue <xavier.roumegue@oss.nxp.com>
diff --git a/drivers/media/platform/nxp/Kconfig b/drivers/media/platform/nxp/Kconfig
index a0ca6b297fb8..55ce6a44b3fd 100644
--- a/drivers/media/platform/nxp/Kconfig
+++ b/drivers/media/platform/nxp/Kconfig
@@ -28,7 +28,7 @@ config VIDEO_IMX_MIPI_CSIS
 	  Video4Linux2 sub-device driver for the MIPI CSI-2 CSIS receiver
 	  v3.3/v3.6.3 found on some i.MX7 and i.MX8 SoCs.
 
-source "drivers/media/platform/nxp/imx8-isi/Kconfig"
+source "drivers/media/platform/nxp/imx-isi/Kconfig"
 
 # mem2mem drivers
 
diff --git a/drivers/media/platform/nxp/Makefile b/drivers/media/platform/nxp/Makefile
index b8e672b75fed..c95d23f1f521 100644
--- a/drivers/media/platform/nxp/Makefile
+++ b/drivers/media/platform/nxp/Makefile
@@ -2,7 +2,7 @@
 
 obj-y += dw100/
 obj-y += imx-jpeg/
-obj-y += imx8-isi/
+obj-y += imx-isi/
 
 obj-$(CONFIG_VIDEO_IMX7_CSI) += imx7-media-csi.o
 obj-$(CONFIG_VIDEO_IMX_MIPI_CSIS) += imx-mipi-csis.o
diff --git a/drivers/media/platform/nxp/imx8-isi/Kconfig b/drivers/media/platform/nxp/imx-isi/Kconfig
similarity index 60%
rename from drivers/media/platform/nxp/imx8-isi/Kconfig
rename to drivers/media/platform/nxp/imx-isi/Kconfig
index fcff33fc2630..ce222fa67a2f 100644
--- a/drivers/media/platform/nxp/imx8-isi/Kconfig
+++ b/drivers/media/platform/nxp/imx-isi/Kconfig
@@ -1,22 +1,22 @@
 # SPDX-License-Identifier: GPL-2.0-only
 
-config VIDEO_IMX8_ISI
-	tristate "i.MX8 Image Sensor Interface (ISI) driver"
+config VIDEO_IMX_ISI
+	tristate "i.MX Image Sensor Interface (ISI) driver"
 	depends on ARCH_MXC || COMPILE_TEST
 	depends on HAS_DMA && PM
 	depends on VIDEO_DEV
 	select MEDIA_CONTROLLER
 	select V4L2_FWNODE
-	select V4L2_MEM2MEM_DEV if VIDEO_IMX8_ISI_M2M
+	select V4L2_MEM2MEM_DEV if VIDEO_IMX_ISI_M2M
 	select VIDEO_V4L2_SUBDEV_API
 	select VIDEOBUF2_DMA_CONTIG
 	help
 	  V4L2 driver for the Image Sensor Interface (ISI) found in various
-	  i.MX8 SoCs.
+	  i.MX SoCs.
 
-config VIDEO_IMX8_ISI_M2M
-	bool "i.MX8 Image Sensor Interface (ISI) memory-to-memory support"
-	depends on VIDEO_IMX8_ISI
+config VIDEO_IMX_ISI_M2M
+	bool "i.MX Image Sensor Interface (ISI) memory-to-memory support"
+	depends on VIDEO_IMX_ISI
 	help
 	  Select 'yes' here to enable support for memory-to-memory processing
 	  in the ISI driver.
diff --git a/drivers/media/platform/nxp/imx-isi/Makefile b/drivers/media/platform/nxp/imx-isi/Makefile
new file mode 100644
index 000000000000..f72e0ce8f17d
--- /dev/null
+++ b/drivers/media/platform/nxp/imx-isi/Makefile
@@ -0,0 +1,8 @@
+# SPDX-License-Identifier: GPL-2.0-only
+
+imx-isi-y := imx-isi-core.o imx-isi-crossbar.o imx-isi-hw.o \
+	imx-isi-pipe.o imx-isi-video.o
+imx-isi-$(CONFIG_DEBUG_FS) += imx-isi-debug.o
+imx-isi-$(CONFIG_VIDEO_IMX_ISI_M2M) += imx-isi-m2m.o
+
+obj-$(CONFIG_VIDEO_IMX_ISI) += imx-isi.o
diff --git a/drivers/media/platform/nxp/imx8-isi/imx8-isi-core.c b/drivers/media/platform/nxp/imx-isi/imx-isi-core.c
similarity index 99%
rename from drivers/media/platform/nxp/imx8-isi/imx8-isi-core.c
rename to drivers/media/platform/nxp/imx-isi/imx-isi-core.c
index 253e77189b69..cd5678139ddf 100644
--- a/drivers/media/platform/nxp/imx8-isi/imx8-isi-core.c
+++ b/drivers/media/platform/nxp/imx-isi/imx-isi-core.c
@@ -23,7 +23,7 @@
 #include <media/v4l2-device.h>
 #include <media/v4l2-mc.h>
 
-#include "imx8-isi-core.h"
+#include "imx-isi-core.h"
 
 /* -----------------------------------------------------------------------------
  * V4L2 async subdevs
@@ -535,5 +535,5 @@ module_platform_driver(mxc_isi_driver);
 
 MODULE_ALIAS("ISI");
 MODULE_AUTHOR("Freescale Semiconductor, Inc.");
-MODULE_DESCRIPTION("IMX8 Image Sensing Interface driver");
+MODULE_DESCRIPTION("IMX Image Sensing Interface driver");
 MODULE_LICENSE("GPL");
diff --git a/drivers/media/platform/nxp/imx8-isi/imx8-isi-core.h b/drivers/media/platform/nxp/imx-isi/imx-isi-core.h
similarity index 99%
rename from drivers/media/platform/nxp/imx8-isi/imx8-isi-core.h
rename to drivers/media/platform/nxp/imx-isi/imx-isi-core.h
index e469788a9e6c..2cb0caf44c42 100644
--- a/drivers/media/platform/nxp/imx8-isi/imx8-isi-core.h
+++ b/drivers/media/platform/nxp/imx-isi/imx-isi-core.h
@@ -327,7 +327,7 @@ int mxc_isi_video_buffer_prepare(struct mxc_isi_dev *isi, struct vb2_buffer *vb2
 				 const struct mxc_isi_format_info *info,
 				 const struct v4l2_pix_format_mplane *pix);
 
-#ifdef CONFIG_VIDEO_IMX8_ISI_M2M
+#ifdef CONFIG_VIDEO_IMX_ISI_M2M
 int mxc_isi_m2m_register(struct mxc_isi_dev *isi, struct v4l2_device *v4l2_dev);
 int mxc_isi_m2m_unregister(struct mxc_isi_dev *isi);
 #else
diff --git a/drivers/media/platform/nxp/imx8-isi/imx8-isi-crossbar.c b/drivers/media/platform/nxp/imx-isi/imx-isi-crossbar.c
similarity index 99%
rename from drivers/media/platform/nxp/imx8-isi/imx8-isi-crossbar.c
rename to drivers/media/platform/nxp/imx-isi/imx-isi-crossbar.c
index f7447b2f4d77..f3e3ed080b07 100644
--- a/drivers/media/platform/nxp/imx8-isi/imx8-isi-crossbar.c
+++ b/drivers/media/platform/nxp/imx-isi/imx-isi-crossbar.c
@@ -1,6 +1,6 @@
 // SPDX-License-Identifier: GPL-2.0-only
 /*
- * i.MX8 ISI - Input crossbar switch
+ * i.MX ISI - Input crossbar switch
  *
  * Copyright (c) 2022 Laurent Pinchart <laurent.pinchart@ideasonboard.com>
  */
@@ -18,7 +18,7 @@
 #include <media/mipi-csi2.h>
 #include <media/v4l2-subdev.h>
 
-#include "imx8-isi-core.h"
+#include "imx-isi-core.h"
 
 static inline struct mxc_isi_crossbar *to_isi_crossbar(struct v4l2_subdev *sd)
 {
diff --git a/drivers/media/platform/nxp/imx8-isi/imx8-isi-debug.c b/drivers/media/platform/nxp/imx-isi/imx-isi-debug.c
similarity index 98%
rename from drivers/media/platform/nxp/imx8-isi/imx8-isi-debug.c
rename to drivers/media/platform/nxp/imx-isi/imx-isi-debug.c
index 6709ab7ea1f3..302bfbd527ea 100644
--- a/drivers/media/platform/nxp/imx8-isi/imx8-isi-debug.c
+++ b/drivers/media/platform/nxp/imx-isi/imx-isi-debug.c
@@ -11,8 +11,8 @@
 #include <linux/seq_file.h>
 #include <linux/types.h>
 
-#include "imx8-isi-core.h"
-#include "imx8-isi-regs.h"
+#include "imx-isi-core.h"
+#include "imx-isi-regs.h"
 
 static inline u32 mxc_isi_read(struct mxc_isi_pipe *pipe, u32 reg)
 {
diff --git a/drivers/media/platform/nxp/imx8-isi/imx8-isi-hw.c b/drivers/media/platform/nxp/imx-isi/imx-isi-hw.c
similarity index 99%
rename from drivers/media/platform/nxp/imx8-isi/imx8-isi-hw.c
rename to drivers/media/platform/nxp/imx-isi/imx-isi-hw.c
index 19e80b95ffea..3803ea1d4073 100644
--- a/drivers/media/platform/nxp/imx8-isi/imx8-isi-hw.c
+++ b/drivers/media/platform/nxp/imx-isi/imx-isi-hw.c
@@ -8,8 +8,8 @@
 #include <linux/io.h>
 #include <linux/types.h>
 
-#include "imx8-isi-core.h"
-#include "imx8-isi-regs.h"
+#include "imx-isi-core.h"
+#include "imx-isi-regs.h"
 
 #define	ISI_DOWNSCALE_THRESHOLD		0x4000
 
diff --git a/drivers/media/platform/nxp/imx8-isi/imx8-isi-m2m.c b/drivers/media/platform/nxp/imx-isi/imx-isi-m2m.c
similarity index 99%
rename from drivers/media/platform/nxp/imx8-isi/imx8-isi-m2m.c
rename to drivers/media/platform/nxp/imx-isi/imx-isi-m2m.c
index 9745d6219a16..5138524ed1d3 100644
--- a/drivers/media/platform/nxp/imx8-isi/imx8-isi-m2m.c
+++ b/drivers/media/platform/nxp/imx-isi/imx-isi-m2m.c
@@ -32,7 +32,7 @@
 #include <media/videobuf2-core.h>
 #include <media/videobuf2-dma-contig.h>
 
-#include "imx8-isi-core.h"
+#include "imx-isi-core.h"
 
 struct mxc_isi_m2m_buffer {
 	struct v4l2_m2m_buffer buf;
diff --git a/drivers/media/platform/nxp/imx8-isi/imx8-isi-pipe.c b/drivers/media/platform/nxp/imx-isi/imx-isi-pipe.c
similarity index 99%
rename from drivers/media/platform/nxp/imx8-isi/imx8-isi-pipe.c
rename to drivers/media/platform/nxp/imx-isi/imx-isi-pipe.c
index c4454aa1cb34..7c1ba4e45f5d 100644
--- a/drivers/media/platform/nxp/imx8-isi/imx8-isi-pipe.c
+++ b/drivers/media/platform/nxp/imx-isi/imx-isi-pipe.c
@@ -23,8 +23,8 @@
 #include <media/v4l2-subdev.h>
 #include <media/videobuf2-v4l2.h>
 
-#include "imx8-isi-core.h"
-#include "imx8-isi-regs.h"
+#include "imx-isi-core.h"
+#include "imx-isi-regs.h"
 
 /*
  * While the ISI receives data from the gasket on a 3x12-bit bus, the pipeline
diff --git a/drivers/media/platform/nxp/imx8-isi/imx8-isi-regs.h b/drivers/media/platform/nxp/imx-isi/imx-isi-regs.h
similarity index 99%
rename from drivers/media/platform/nxp/imx8-isi/imx8-isi-regs.h
rename to drivers/media/platform/nxp/imx-isi/imx-isi-regs.h
index 1b65eccdf0da..2b4f8248b761 100644
--- a/drivers/media/platform/nxp/imx8-isi/imx8-isi-regs.h
+++ b/drivers/media/platform/nxp/imx-isi/imx-isi-regs.h
@@ -3,8 +3,8 @@
  * Copyright 2019-2020 NXP
  */
 
-#ifndef __IMX8_ISI_REGS_H__
-#define __IMX8_ISI_REGS_H__
+#ifndef __IMX_ISI_REGS_H__
+#define __IMX_ISI_REGS_H__
 
 #include <linux/bits.h>
 
@@ -415,4 +415,4 @@
 /* Channel Input Buffer Extended Address Bits */
 #define CHNL_IN_BUF_XTND_ADDR					0x00b8
 
-#endif /* __IMX8_ISI_REGS_H__ */
+#endif /* __IMX_ISI_REGS_H__ */
diff --git a/drivers/media/platform/nxp/imx8-isi/imx8-isi-video.c b/drivers/media/platform/nxp/imx-isi/imx-isi-video.c
similarity index 99%
rename from drivers/media/platform/nxp/imx8-isi/imx8-isi-video.c
rename to drivers/media/platform/nxp/imx-isi/imx-isi-video.c
index 10840c9a0912..0b5cc7c08332 100644
--- a/drivers/media/platform/nxp/imx8-isi/imx8-isi-video.c
+++ b/drivers/media/platform/nxp/imx-isi/imx-isi-video.c
@@ -1,8 +1,8 @@
 // SPDX-License-Identifier: GPL-2.0
 /*
- * V4L2 Capture ISI subdev driver for i.MX8QXP/QM platform
+ * V4L2 Capture ISI subdev driver for i.MX platform
  *
- * ISI is a Image Sensor Interface of i.MX8QXP/QM platform, which
+ * ISI is a Image Sensor Interface of i.MX platform, which
  * used to process image from camera sensor to memory or DC
  *
  * Copyright (c) 2019 NXP Semiconductor
@@ -30,8 +30,8 @@
 #include <media/videobuf2-dma-contig.h>
 #include <media/videobuf2-v4l2.h>
 
-#include "imx8-isi-core.h"
-#include "imx8-isi-regs.h"
+#include "imx-isi-core.h"
+#include "imx-isi-regs.h"
 
 /* Keep the first entry matching MXC_ISI_DEF_PIXEL_FORMAT */
 static const struct mxc_isi_format_info mxc_isi_formats[] = {
diff --git a/drivers/media/platform/nxp/imx8-isi/Makefile b/drivers/media/platform/nxp/imx8-isi/Makefile
deleted file mode 100644
index 9bff9297686d..000000000000
--- a/drivers/media/platform/nxp/imx8-isi/Makefile
+++ /dev/null
@@ -1,8 +0,0 @@
-# SPDX-License-Identifier: GPL-2.0-only
-
-imx8-isi-y := imx8-isi-core.o imx8-isi-crossbar.o imx8-isi-hw.o \
-	imx8-isi-pipe.o imx8-isi-video.o
-imx8-isi-$(CONFIG_DEBUG_FS) += imx8-isi-debug.o
-imx8-isi-$(CONFIG_VIDEO_IMX8_ISI_M2M) += imx8-isi-m2m.o
-
-obj-$(CONFIG_VIDEO_IMX8_ISI) += imx8-isi.o